/*
 *	V8dis.c:	straightforward V8 dissassembler.
 *	Creation date:	29-09-2004
 *	Created by:	Allard van der Bas
 *	Contact:	pv2@digitalfluff.net
 *	Web address:	http://www.digitalfluff.net/pv2/
 *
 */
#include <stdio.h>
#include <stdlib.h>

#include "tables.h"

int main(int argc,char **argv) {
	FILE *f;
	int count;

	int codestart;

	unsigned char val1;
	unsigned char val2;
	unsigned char val3;

	if (argc < 3) {
		printf("Usage: %s <filename> <codestart>\n",argv[0]);
		printf("Where <filename> is the file to use.\n");
		printf("      <codestart> is where to map the file in memory.\n");
		printf("Example: %s t02-a02-f02.pack 0406\n",argv[0]);
		exit(1);
	}

	sscanf(argv[2],"%04X",&codestart);

	f = fopen(argv[1],"rb");
	if (!f) {
		printf("Error opening file %s\n",argv[1]);
		exit(1);
	}

	count = codestart;
	while (!feof(f)) {
		fread(&val1,1,1,f);

		if (noopcode[val1] == 1) {
			printf("0x%04X 0x%02X\t\t%s\n",count,val1,opcodes[val1] );
			count++;
		} else if (noopcode[val1] == 2) {
			fread(&val2,1,1,f);
			printf("0x%04X 0x%02X 0x%02X\t%s #$%02X\n",count,val1,val2,opcodes[val1],val2);
			count++;
			count++;
		} else if (noopcode[val1] == 3) {
			fread(&val2,1,1,f);
			fread(&val3,1,1,f);
			printf("0x%04X 0x%02X 0x%02X 0x%02X\t%s $%02X%02X\n",count,val1,val2,val3,opcodes[val1],val3,val2);
			count++;
			count++;
			count++;
		}

	}
	return(0);
}
