/*
 *  This file contains the V8 tables needed by V8sim and V8dis.
 *
 *  Creation data:	29-09-2004
 *  Created by:		Allard van der Bas
 *  Contact:		pv2@digitalfluff.net
 *
 *  Changes 24-11-2004
 *  Changed names of a number of opcodes to more descriptive
 *  names: Flag handling CLC,SEC,CLI,SEI,SEZ,CLZ,SEN,CLN.
 *         Branching     BNE,BEQ,BCC,BCS,BPL,BMI,BIC,BIS
 */
#ifndef __TABLES_H__
#define __TABLES_H__

int clockcycles[256] = {
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
 5,0,0,0,0,0,0,0,7,7,7,7,7,7,7,7,
 5,0,0,0,0,0,0,0,5,5,5,5,3,0,0,5,
 2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,
 3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,
 2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,
 3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4 
};

int noopcode[256] = {
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,

 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
 1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,3,
 1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,
 1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,
 2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,
 1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2
};

char opcodes[256][7] = {
 "INC R0","INC R1","INC R2","INC R3","INC R4","INC R5","INC R6","INC R7",
 "ADC R0","ADC R1","ADC R2","ADC R3","ADC R4","ADC R5","ADC R6","ADC R7",

 "TX0 R0","TX0 R1","TX0 R2","TX0 R3","TX0 R4","TX0 R5","TX0 R6","TX0 R7",
 "OR  R0","OR  R1","OR  R2","OR  R3","OR  R4","OR  R5","OR  R6","OR  R7",

 "AND R0","AND R1","AND R2","AND R3","AND R4","AND R5","AND R6","AND R7",
 "XOR R0","XOR R1","XOR R2","XOR R3","XOR R4","XOR R5","XOR R6","XOR R7",

 "ROL R0","ROL R1","ROL R2","ROL R3","ROL R4","ROL R5","ROL R6","ROL R7",
 "ROR R0","ROR R1","ROR R2","ROR R3","ROR R4","ROR R5","ROR R6","ROR R7",

 "DEC R0","DEC R1","DEC R2","DEC R3","DEC R4","DEC R5","DEC R6","DEC R7",
 "SBC R0","SBC R1","SBC R2","SBC R3","SBC R4","SBC R5","SBC R6","SBC R7",

 "ADD R0","ADD R1","ADD R2","ADD R3","ADD R4","ADD R5","ADD R6","ADD R7",
 "SEZ   ","SEC   ","SEN   ","SEI  ","STP 4 ","STP 5 ","STP 6 ","STP 7 ",

 "BTT 0 ","BTT 1 ","BTT 2 ","BTT 3 ","BTT 4 ","BTT 5 ","BTT 6 ","BTT 7 ",
 "CLZ   ","CLC   ","CLN   ","CLI   ","CLP 4 ","CLP 5 ","CLP 6 ","CLP 7 ",

 "T0X R0","T0X R1","T0X R2","T0X R3","T0X R4","T0X R5","T0X R6","T0X R7",
 "CMP R0","CMP R1","CMP R2","CMP R3","CMP R4","CMP R5","CMP R6","CMP R7",

 "PSH R0","PSH R1","PSH R2","PSH R3","PSH R4","PSH R5","PSH R6","PSH R7",
 "POP R0","POP R1","POP R2","POP R3","POP R4","POP R5","POP R6","POP R7",

 "BNE   ","BCC   ","BPL   ","BIC   ","BR0 4,","BR0 5,","BR0 6,","BR0 7,",
 "BEQ   ","BCS   ","BMI   ","BIS   ","BR1 4,","BR1 5,","BR1 6,","BR1 7,",

 "USR   ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ",
 "INT 0 ","INT 1 ","INT 2 ","INT 3 ","INT 4 ","INT 5 ","INT 6 ","INT 7 ",

 "USR2  ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ","NOP   ",
 "RSP   ","RTS   ","RTI   ","BRK   ","JMP   ","NOP   ","NOP   ","JSR",

 "UPP R0","UPP R1","UPP R2","UPP R3","UPP R4","UPP R5","UPP R6","UPP R7",
 "STA R0","STA R1","STA R2","STA R3","STA R4","STA R5","STA R6","STA R7",

 "STX R0","STX R1","STX R2","STX R3","STX R4","STX R5","STX R6","STX R7",
 "STO R0","STO R1","STO R2","STO R3","STO R4","STO R5","STO R6","STO R7",

 "LDI R0","LDI R1","LDI R2","LDI R3","LDI R4","LDI R5","LDI R6","LDI R7",
 "LDA R0","LDA R1","LDA R2","LDA R3","LDA R4","LDA R5","LDA R6","LDA R7",

 "LDX R0","LDX R1","LDX R2","LDX R3","LDX R4","LDX R5","LDX R6","LDX R7",
 "LDO R0","LDO R1","LDO R2","LDO R3","LDO R4","LDO R5","LDO R6","LDO R7"
};

#endif
